SeeingRed = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceEvent-2.0", "AceConsole-2.0")
local oldAlpha, fadeTime, maxOpacity = 0
--[[--------------------------------------------------------------------------------
  Setup
-----------------------------------------------------------------------------------]]
function SeeingRed:OnInitialize()
	self:RegisterDB("SeeingRedDB")
	self:RegisterDefaults('profile', {
		fadeTime = 0.25,
		maxOpacity = 1,
	})
	self:RegisterChatCommand({"/seeingred"}, {
		type = "group",
		args = {
			fadeTime = {
				name = "Fade Time", type = "range",
				desc = "Fade in/out time (in seconds).",
				get = function() return self.db.profile.fadeTime end,
				set = function(time) self.db.profile.fadeTime = time end,
				usage = "<time>"
			},
			maxOpacity = {
				name = "Maximum Opacity", type = "range",
				desc = "Maximum opacity (alpha will be scaled by this factor).",
				get = function() return self.db.profile.maxOpacity end,
				set = function(opacity) self.db.profile.maxOpacity = opacity end,
				usage = "<opacity>"
			},
		}
	})
end
function SeeingRed:OnEnable()
	local pclass = select(2, UnitClass('player'))
	if pclass == "WARRIOR" or pclass == "DRUID" then
		self:RegisterEvent("UNIT_RAGE")
		if pclass == "DRUID" then
			self:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
		end
		LowHealthFrame:Show()
		LowHealthFrame:SetAlpha(0)
		fadeTime = self.db.profile.fadeTime
		maxOpacity = self.db.profile.maxOpacity
	end
end
function SeeingRed:OnDisable()
	LowHealthFrame:Hide()
	self:UnregisterAllEvents()
end
--[[--------------------------------------------------------------------------------
  Events
-----------------------------------------------------------------------------------]]
function SeeingRed:UNIT_RAGE()
	if arg1 ~= 'player' then return end
	local newAlpha =  UnitMana('player') * maxOpacity / 100
	UIFrameFadeIn(LowHealthFrame, self.db.profile.fadeTime, oldAlpha, newAlpha)
	oldAlpha = newAlpha
end

function SeeingRed:UPDATE_SHAPESHIFT_FORMS()
	if UnitPowerType('player') ~= 1 then
		UIFrameFadeIn(LowHealthFrame, self.db.profile.fadeTime/2, oldAlpha, 0)
		oldAlpha = 0
	end
end
